player = {x = 90,
  y = 60,
  xs = 0,
  ys = 0,
  dir = 1,
  sprite = love.graphics.newImage("graphics/placide.png"),
  atk = 1,
  def = 1,
  hp = 10
}

inventory = {}

math.randomseed(os.time())
room = 1
letter = 1
sentence = 1
animation = 0
mask = math.random(20)
debug = false
scale = 3

function love.load()
  local file = love.filesystem.newFile("data/rooms.txt")
  file:open("r")
  rooms = {}
  for line in file:lines() do
    if line:find("nEw") then 
      table.insert(rooms, {}) 
      new = true
    elseif new then
      rooms[#rooms].tileset = line
      new = false
    else
      table.insert(rooms[#rooms], {})
      for i=1,line:len() do
        table.insert(rooms[#rooms][#rooms[#rooms]], tonumber(line:sub(i, i),36))
      end
    end
  end
  file:close()

  local file = love.filesystem.newFile("data/warps.txt")
  file:open("r")
  warps = {}
  for line in file:lines() do
    if line:find("nEw") then 
      table.insert(warps, {}) 
      new = 1
    elseif new == 1 then
      table.insert(warps[#warps], {})
      warps[#warps][#warps[#warps]].x = tonumber(line)
      new = 2
    elseif new == 2 then
      warps[#warps][#warps[#warps]].y = tonumber(line)
      new = 3
    elseif new == 3 then
      warps[#warps][#warps[#warps]].d = tonumber(line)
      new = 4
    elseif new == 4 then
      warps[#warps][#warps[#warps]].dx = tonumber(line)
      new = 5
    elseif new == 5 then
      warps[#warps][#warps[#warps]].dy = tonumber(line)
      new = 1
    end
  end
  file:close()

  local file = love.filesystem.newFile("data/npcs.txt")
  file:open("r")
  chars = {}
  for line in file:lines() do
    if line:find("nEw") then 
      table.insert(chars, {}) 
    elseif line:find("cHa") then
      table.insert(chars[#chars], {})
      new = 1
    elseif new == 1 then
      chars[#chars][#chars[#chars]].name = line
      new = 2
    elseif new == 2 then
      chars[#chars][#chars[#chars]].x = tonumber(line)
      new = 3
    elseif new == 3 then
      chars[#chars][#chars[#chars]].y = tonumber(line)
      new = 4
    elseif new == 4 then
      chars[#chars][#chars[#chars]].dir = tonumber(line)
      new = 0
    else
      table.insert(chars[#chars][#chars[#chars]], line)
    end
  end
  file:close()

  wW, wH = love.window.getMode()
  
  talks = {adonis = love.audio.newSource("sound/adonis.wav")}
  sprites = {adonis = love.graphics.newImage("graphics/adonis.png"), cadwal = love.graphics.newImage("graphics/cadwal.png"), morgane = love.graphics.newImage("graphics/morgane.png"), sheldan = love.graphics.newImage("graphics/sheldan.png")}
  masks = love.graphics.newImage("graphics/masks.png")
  
  mQuads = {}
  local width = 10
  local height = 9
  local image_width = 56
  local image_height = 41
  for i=0,3 do
    for j=0,4 do
      table.insert(mQuads, love.graphics.newQuad(1 + j *(width + 1), 1 + i *(height + 1), width, height, image_width, image_height))
    end
  end
  
  pQuads = {}
  local width = 30
  local height = 30
  local image_width = 125
  local image_height = 125
  for i=0,3 do
    for j=0,3 do
      table.insert(pQuads, love.graphics.newQuad(1 + j *(width + 1), 1 + i *(height + 1), width, height, image_width, image_height))
    end
  end
  
  sQuads = {}
  local width = 30
  local height = 30
  local image_width = 63
  local image_height = 63
  for i=0,1 do
    for j=0,1 do
      table.insert(sQuads, love.graphics.newQuad(1 + j *(width + 1), 1 + i *(height + 1), width, height, image_width, image_height))
    end
  end
  
  love.audio.setVolume(1)
  font = love.graphics.newFont("freepixel.ttf", 16)
  love.graphics.setFont(font)
  
  tilesets = {}
  for i=0,0 do
    tilesets[tostring(i)] = love.graphics.newImage("graphics/tileset" .. i .. ".png")
  end
  
  tQuads = {}
  local width = 30
  local height = 30
  local image_width = 187
  local image_height = 187
  for i=0,5 do
    for j=0,5 do
      table.insert(tQuads, love.graphics.newQuad(1 + j *(width + 1), 1 + i *(height + 1), width, height, image_width, image_height))
    end
  end
  
  canvas = love.graphics.newCanvas(800, 600)
end

function love.update(dt)
  collisionset = love.image.newImageData("graphics/tileset" .. rooms[room].tileset .. ".png")
  
  if love.keyboard.isDown("up") and not dialog and player.xs == 0 then 
    player.ys = -1 
    player.dir = 2
  end
  if love.keyboard.isDown("down") and not dialog and player.xs == 0 then 
    player.ys = 1 
    player.dir = 4
  end
  if love.keyboard.isDown("left") and not dialog and player.ys == 0 then 
    player.xs = -1 
    player.dir = 1
  end
  if love.keyboard.isDown("right") and not dialog and player.ys == 0 then 
    player.xs = 1 
    player.dir = 3
  end
  
  if (math.abs(player.xs) == 1 or math.abs(player.ys) == 1) then
    animation = (animation + 0.5) % 4
  end
  if player.x%30 == 0 and player.y%30 == 0 then 
    quadvalue = rooms[room][(player.y + 30 * player.ys)/30][(player.x + 30 * player.xs)/30]
    color = {}
    color[1], color[2], color[3], color[4] = collisionset:getPixel(31*(quadvalue%6), 31*math.floor(quadvalue/6))
    if color[4] == 255 then
      player.xs = 0
      player.ys = 0
      animation = 0
    end
  end
  if (math.abs(player.xs) == 1 or math.abs(player.ys) == 1) and player.x%30 == 0 and player.y%30 == 0 then
    for i,v in ipairs(chars[room]) do
      if v.x*30 == player.x + 30 * player.xs and v.y*30 == player.y + 30 * player.ys then
        player.xs = 0
        player.ys = 0
        animation = 0
        if mask ~= 14 then
          dialog = true
          talkingTo = i
          if talks[v.name:lower()] then talks[v.name:lower()]:play() end
        end
      end
    end
  end
  
  player.x = player.x + player.xs * 3
  player.y = player.y + player.ys * 3
  if mask == 6 then
    player.x = player.x + player.xs * 3
    player.y = player.y + player.ys * 3
    if (math.abs(player.xs) == 1 or math.abs(player.ys) == 1) then
      animation = (animation + 0.5) % 4
    end
  end
  
  if player.x%30 == 0 and player.y%30 == 0 then
    local stop = true
    for i,v in ipairs(warps[room]) do
      if v.x*30 == player.x and v.y*30 == player.y then
        player.x = v.dx * 30
        player.y = v.dy * 30
        room = v.d
        stop = false
      end
    end
    if stop then
      player.xs = 0
      player.ys = 0
      animation = 0
    end
  end
end

function love.draw()
  love.graphics.push()
  
  love.graphics.setColor(255, 255, 255, 255)
  
  love.graphics.setCanvas(canvas)
    
    love.graphics.clear()
    
    local tileset = tilesets[rooms[room].tileset]
    
    for y,row in ipairs(rooms[room]) do
      for x,v in ipairs(row) do
        love.graphics.draw(tileset, tQuads[1], x * 30, y * 30)
        love.graphics.draw(tileset, tQuads[v+1], x * 30, y * 30)
      end
    end
    
    for i,v in ipairs(chars[room]) do
      local dir = math.atan2(player.y - v.y*30, player.x - v.x*30) + math.pi
      local ddir = math.floor(dir/math.pi*2)%4+1
      if sprites[v.name:lower()] then
        if v.dir == 0 then love.graphics.draw(sprites[v.name:lower()], sQuads[ddir], v.x * 30, v.y * 30) else love.graphics.draw(sprites[v.name:lower()], sQuads[v.dir], v.x * 30, v.y * 30) end
      end
    end
    
    love.graphics.draw(player.sprite, pQuads[player.dir+4*math.floor(animation)], player.x, player.y)
    if player.dir == 4 then love.graphics.draw(masks, mQuads[mask], player.x+10, player.y+3) end
  
  love.graphics.setCanvas()
  
  love.graphics.translate(wW/2 - scale*(player.x + 15), wH/2 - scale*(player.y + 15))
  love.graphics.scale(scale)
  canvas:setFilter("nearest", "nearest")
  love.graphics.draw(canvas)
  
  love.graphics.pop()
  
  if dialog then
    love.graphics.setColor(50, 50, 50, 255)
    love.graphics.rectangle("fill", 0, 500, 800, 100)
    love.graphics.setColor(255, 255, 255, 255)
    love.graphics.printf(chars[room][talkingTo][sentence]:sub(1, letter), 100, 505, 500)
    if letter < chars[room][talkingTo][sentence]:len() then letter = letter + 1 end
  end
end

function love.keypressed(key, scan)
  if scan == "z" and dialog and letter == chars[room][talkingTo][sentence]:len() then
    sentence = sentence + 1
    letter = 0
    if sentence > #chars[room][talkingTo] then
      sentence = 1
      dialog = false
    end
  end
  if scan == "x" and dialog then
    letter = chars[room][talkingTo][sentence]:len()
  end
  if key == "m" and debug then
    mask = mask%20+1
  end
  if scan == "escape" then debug = not debug end
end